#include <qapplication.h>
#include <qwidget.h>
#include <qcombobox.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qmessagebox.h>
#include <qpoint.h>
#include <qsocketnotifier.h>
#include <iostream.h>
#include "sd.hpp"
#include "dialdlg.h"

class cDialer : public QDialog {
	Q_OBJECT

public:
	cDialer(QWidget *parent=0, const char *name=0, bool modal=TRUE);
	virtual ~cDialer(void); 
	
	void openDevice(const char *device="/dev/modem");
	void closeDevice(void);
	void setDialID(const char *ID, int port=1);
	
public slots:
	void showDialog(void);
	void startDial(void);
	void hideDialog(void);

signals:
	void userCanceled(void);
	void timeout(void);
	void localBusy(void);
	void waiting(void);
	void done(void);
	void noResult(void);

private:
	ocSpeedDragon *SD;
	dialDlg *status;
	QSocketNotifier *sdEvent;
	QLineEdit *le_id;
	QComboBox *combo_port;
	QPushButton *pb_dial, *pb_cancel;
	bool cIsDeviceOpen;
	
	void connectNotifier(void);
	
private slots:
	void dialEvent(void);
	void dialCanceled(void);

};
