#include "edit.h"

cEdit::cEdit(QWidget *parent, const char *name, bool modal,
	const char *caption): QDialog(parent, name, modal)
{
	setCaption(caption);
	setFixedSize(280,125);
	
	
	le_description=new QLineEdit(this);
	QLabel *l_description=new QLabel("Beschreibung:", this);
	l_description->move(35, 10);
	le_description->move(150,10);
	le_description->setFixedHeight(25);
	le_description->setStyle(WindowsStyle);
	le_description->setFocus();
	
	le_id=new QLineEdit(this);
	le_id->move(150,40);
	QLabel *l_id=new QLabel("Rufnummer:", this);
	l_id->move(35, 40);
	le_id->setFixedHeight(25);
	le_id->setStyle(WindowsStyle);
	
	pb_ok=new QPushButton("OK", this);
	pb_ok->move(35,85);
	pb_ok->setStyle(WindowsStyle);
	pb_ok->setDefault(TRUE);
	connect(pb_ok, SIGNAL(clicked()), SLOT(validateAccept()));
	
	pb_cancel=new QPushButton("Abbrechen",this);
	pb_cancel->move(150,85);
	pb_cancel->setStyle(WindowsStyle);
	connect(pb_cancel, SIGNAL(clicked()), SLOT(reject()));
}

void cEdit::setID(const char *ID) {
	le_id->setText(ID);
}

char* cEdit::getID(void) {
	return((char*)le_id->text());
}

void cEdit::setDescription(const char *text) {
	le_description->setText(text);
}

char* cEdit::getDescription(void) {
	return((char*)le_description->text());
}
	
void cEdit::validateAccept(void) {

	int i;
	
	for (i=0; i<(signed int)strlen(getID()); i++) {
		if (!(isdigit(getID()[i]))) {
			QMessageBox::warning(this, "Fehler",
				"Die Rufnummer enthlt mindestens\nein ungltiges Zeichen!");
			return;
		}
	}
	accept();
}
