#ifndef QTDIAL_H
#define QTDIAL_H

#include <qapp.h>
#include <qmainwindow.h>
#include <qmenubar.h>
#include <qstatusbar.h>
#include <qframe.h>
#include <qlistview.h>
#include <iostream.h>

#include "../src/rcfile.h"
#include "edit.h"
#include "dialer.h"

class qtDial : public QMainWindow {
	Q_OBJECT

public:
	qtDial(QWidget *parent=0, const char *name=0);
	virtual ~qtDial(void);
	
	void initDialerDevice(void);
	
public slots:
	void insertItem(void);
	void dialCurrentItem(void);
	void deleteCurrentItem(void);
	void editCurrentItem(void);
	void itemPopupMenu(QListViewItem *item, const QPoint &point, int col);
	void readRcFile(void);
	void writeRcFile(void);

private:
	QListView *table;
	QMenuBar *menubar;
	QPopupMenu *edit;
	cDialer *dialDlg;
	rcFile configFile;
	
	void createMenubar(void);
	void resizeEvent(QResizeEvent *event);

private slots:
	void editMenuSelected(void);
};


#endif
