#ifndef MINICON_H
#define MINICON_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <termios.h>
#include <fcntl.h>
#include <time.h>

enum tStatus { sReady, sWaitingForTransfer, sUnknownError };

class miniCon {

public:
	miniCon(const char *devicename="/dev/modem");
	
	void openDevice();
	void closeDevice();
	tStatus getLastStatus(void);
	bool isDeviceOpen(void) { return(iIsOpen); }
	void setTimeout(int sec=0);
	void sendString(const char* string);
	int waitString(const char *str1, const char *str2=NULL);
	bool checkDragon(void);
	
private:
	char device[128];
	int fd, time;
	long bitrate;
	bool iIsOpen;
	tStatus iStatus;
	
	void initDevice(void);
	long detectBaudrate(struct termios terminal);
	long detectNAK(struct termios terminal);
	char getChar(void);
};

#endif
