//
// connect.hpp
//
// (c) Jan Willamowius, 1998
//
// free for private use - commercial use or commercial distribution
// requires permission from the author
//

#ifndef CONNECT_HPP
#define CONNECT_HPP


#include <string>		// string-Klasse
#ifdef linux
#include <termio.h>		// struct termio
#endif
 
#ifdef _MSC_VER
#include <windows.h>
using namespace std;
#endif

class ocConnection
{
public:
	ocConnection(const string & sNewDevice);
	virtual ~ocConnection();
	bool bDeviceLocked(void);
	void vOpen(void);
	void vClose(void);
	void vConnect(const string & sDialStr);
	void vHangup(void);
	bool bIsOpen(void) const;
	void vSetInitStr(const string & sNewInitStr);
	string sGetInitStr(void) const;
	void vSetBps(int iNewBps);
	void vAutoSetBps(void);
	int iGetBps(void) const;
	void vSetEcho(const bool bNewEcho);
	bool bGetEcho(void) const;
	void vSetTimeout(const int iNewTimeout);	// seconds
	int iGetTimeout(void) const;				// seconds
	void vSendChar(const char ch) const;
	void vSendString(const string & sSt) const;
	void vReceiveChar(void);
	void vReceiveString(void);
	char chGetLastChar(void) const;
	string sGetLastString(void) const;
	void vWaitString(const string & sSt1);
	void vWaitString(const string & sSt1, const string & sSt2);
	void vWaitString(const string & sSt1, const string & sSt2, const string & sSt3);
	void vWaitString(const string & sSt1, const string & sSt2, const string & sSt3, const string & sSt4);
	int iStringFound(void) const;	// Which string was found ?

	// use with care: access to low level file descriptor
	int iGetFileDescriptor(void);

protected:
	string sGetLockfileName(void);
	void vLockDevice(void);
	void vUnlockDevice(void);

	string sDevice;		// Name des Unix Device ueber das die
						// Verbindung aufgebaut werden soll
#ifdef linux
	struct termio xtermio;   // Termio-Daten des Device
	int iDeviceHandle;	// Unix File-Handle des Device
#endif
#ifdef _MSC_VER
	HANDLE idComDev;	// Handle des Device
#endif
	bool bEcho;			// alle empfangenen Zeichen werden auf dem
						// Bildschirm ausgegeben
	char chLastChar;	// das zuletzt gelesene Zeichen
	string sLastString;	// zuletzt gelesener string
	string sInitStr;	// Init-string fuer das Modem
	int iBps;			// Bps der Verbindung
	int iTimeout;
	bool bOpenStatus;	// Verbindung erfolgreich geoeffnet ?
	int iWhichString;	// Nummer des bei WitString gefundenen Strings
						// 0 fuer nicht-gefunden
};

#endif
