//
// sd.h
//
// (c) Jan Willamowius, 1998
//
// free for private use - commercial use or commercial distribution
// requires permission from the author
//

#ifndef SD_H
#define SD_H

#ifdef __cplusplus
extern "C" {
#endif

typedef int tPort;
/*
enum tAmtsBerechtigung {Halbamt=1, Ortsamt=2, National=3,  International=4};
enum tDisplayPart {OnlyRedirectedMSN=0, AllMSN=1, CallList=2, Charges=3, BChannels=4, IncommingCalls=5, ExtendedBChannels=6};
enum tLanguage {Deutsch=0, English, Franzoesisch, Italienisch, Flaemisch, Daenisch, Norwegisch};
enum tISDNNet {ETSI=0, Belgium=1, Italy=2};
enum tDialResult {NoResult=0, Waiting=1, Done=2, Timeout=3, PortBusy=4};
*/

void sd_vInit(const char * sDevice, int iBps);
void sd_vCleanup();

void sd_vOpen(void);
void sd_vClose(void);
int sd_bIsOpen(void);
void sd_vSetDebug(int bOn);

void sd_sGetFirmwareRevision(char * psBuf, int iBufSize);

void sd_vClearCallList(void);
void sd_vSetAmtsBerechtigungPort(tPort xNo, int xAmt);
int sd_xGetAmtsBerechtigungPort(tPort xNo);
void sd_vSetAmtsBerechtigungPBX(int xAmt);
int sd_xGetAmtsBerechtigungPBX(void);
void sd_vSetGebuehrenfaktorPort(tPort xNo, int iFaktor);
int sd_iGetGebuehrenfaktorPort(tPort xNo);
void sd_vSetGebuehrenfaktorPBX(int iFaktor);
int sd_iGetGebuehrenfaktorPBX(void);
int sd_iGetSummenzaehlerPort(tPort xNo);
int sd_iGetSummenzaehlerPBX(void);
void sd_vClearSummenzaehlerPort(tPort xNo);
void sd_vClearSummenzaehlerPBX(void);
void sd_vRufumleitungCFUOn(const char * sMSN);
void sd_vRufumleitungCFUOff(const char * sMSN);
int sd_bGetRufumleitungCFUActive(const char * sMSN);
void sd_vSetRufumleitungCFU(const char * sMSN, const char * sNumber);
void sd_sGetRufumleitungCFU(const char * sMSN, char * psBuf, int iBufSize);
void sd_vRufumleitungBK2On(const char * sMSN);
void sd_vRufumleitungBK2Off(const char * sMSN);
int sd_bGetRufumleitungBK2Active(const char * sMSN);
void sd_vSetRufumleitungBK2(const char * sMSN, const char * sNumber);
void sd_sGetRufumleitungBK2(const char * sMSN, char * psBuf, int iBufSize);
void sd_vAllRufumleitungenOff(void);
void sd_vSetCallerIDSupression(const char * sMSN, int xOn);
int sd_bGetCallerIDSupression(const char * sMSN);
void sd_vSetSammelrufEintrag(tPort xNo, int bOn);
int sd_bGetSammelrufEintrag(tPort xNo);
void sd_vSetPseudoDialtone(tPort xNo, int bOn);
int sd_bGetPseudoDialtone(tPort xNo);
void sd_vSetAnklopfen(tPort xNo, int bOn);
int sd_bGetAnklopfen(tPort xNo);
void sd_vSetDisplayPart(int xPart, int bOn);
int sd_bGetDisplayPart(int xPart);
void sd_vSetLanguage(int xLanguage);
int sd_xGetLanguage(void);
void sd_vSetISDNNet(int xISDN);
int sd_xGetISDNNet(void);
void sd_vClearPortMSN(tPort xNo);
void sd_vClearSammelrufMSN(void);
void sd_vClearFernprogMSN(void);
void sd_vSetPortMSN(tPort xNo,const char * sMSN);
void sd_sGetPortMSN(tPort xNo, char * psBuf, int iBufSize);
void sd_vSetSammelrufMSN(const char * sMSN);
void sd_sGetSammelrufMSN(char * psBuf, int iBufSize);
void sd_vSetFernprogMSN(const char * sMSN);
void sd_sGetFernprogMSN(char * psBuf, int iBufSize);
void sd_vSetLocation(const char * sCountry, const char * sArea);
void sd_sGetLocation(char * psBuf, int iBufSize);

// dialling support
void sd_vDial(tPort xNo, const char * sNumber);
int sd_xWaitForDialResult(tPort xNo);

#ifdef __cplusplus
}
#endif

#endif

