//
// sd_dial.cpp
//
// (c) Jan Willamowius, 1998
//
// free for private use - commercial use or commercial distribution
// requires permission from the author
//

#include <iostream>
#include <string.h>
#include "sd.hpp"


int main(int argc, char** argv)
{
	if (argc != 3)
	{
		cout << "Usage: sd_dial <port> <destination>" << endl;
		exit(1);
	};

#ifdef linux
        // i made a link to the serial device my SpeedDragon is connected to
        ocSpeedDragon oSD("/dev/speeddragon");
#endif
#ifdef _MSC_VER
        ocSpeedDragon oSD("COM1", 115200);
#endif

//	oSD.vSetDebug(true);

	oSD.vOpen();
	if (oSD.bIsOpen())
	{
		tPort xPort = (argv[1][0]) - '0';
		string sDestination(argv[2]);
		if ((xPort < 1) || (xPort > 4)) {
			cout << "SD: Invalid port (" << xPort << ")" << endl;
			exit(1);
		};
		cout << endl << "Dialing " << xPort << "->" << sDestination << "..." << endl;
		oSD.vDial(xPort, sDestination);
		cout << "Please pick up port " << xPort << endl;
		tDialResult xResult = Waiting;
		oSD.vSetTimeout(40);
		while (xResult == Waiting)
		{
			xResult = oSD.xWaitForDialResult(1);
		};
		switch(xResult)
		{
			case Done:
				cout << "Done" << endl;
				break;
			case Timeout:
				cout << "Timeout" << endl;
				break;
			case PortBusy:
				cout << "PortBusy" << endl;
				break;
			default:
				cout << "Irregular abort" << endl;
				break;
		}
		oSD.vClose();
	}
	else
		cout << "SpeedDragon not ready" << endl;
	
	cout << endl;

	return 0;
}

