//
// sd_printconfig.cpp
//
// (c) Jan Willamowius, 1998
//
// free for private use - commercial use or commercial distribution
// requires permission from the author
//

#include <iostream>
#include "sd.hpp"
#include <list>


int main(void)
{
	int i=0;
#ifdef linux
	// i made a link to the serial device my SpeedDragon is connected to
	ocSpeedDragon oSD("/dev/speeddragon");
#endif
#ifdef _MSC_VER
	ocSpeedDragon oSD("COM1", 115200);
#endif

//	oSD.vSetDebug(true);
	oSD.vOpen();
	if (oSD.bIsOpen())
	{
		cout << "SpeedDragon ready:" << endl;
		cout << "Firmware Revision " << oSD.sGetFirmwareRevision() << endl;
		cout << "Sprache : " << oSD.xGetLanguage() << endl;
		cout << "Location : " << oSD.sGetLocation() << endl;
		cout << "ISDN-Netzkennung : " << oSD.xGetISDNNet() << endl;
		cout << "PBX-Gebuehrenfaktor : " << oSD.iGetGebuehrenfaktorPBX() << "." << oSD.iGetGebuehrenNachkommaPBX() << endl;
		cout << "PBX-Gebuehrenzaehler : " << oSD.iGetSummenzaehlerPBX() << endl;
		for (i=1; i <= 4; i++)
		{
			cout << "Port " << i << "\tMSN = " << oSD.sGetPortMSN(i) << endl;
			cout << "\t" << "PseudoDialtone = " << oSD.bGetPseudoDialtone(i) << endl;
			cout << "\t" << "Anklopfen = " << oSD.bGetAnklopfen(i) << endl;
			cout << "\t" << "Besetztton = " << oSD.xGetBusyTone(i) << endl;
			cout << "\t" << "Gebuehrenfaktor = " << oSD.iGetGebuehrenfaktorPort(i) << "." << oSD.iGetGebuehrenNachkommaPort(i) << endl;
			cout << "\t" << "Gebuehrenzaehler = " << oSD.iGetSummenzaehlerPort(i) << endl;
		};
		for (i=0; i <= 6; i++)
		{
			cout << "DisplayPart " << i << " = " << oSD.bGetDisplayPart(tDisplayPart(i)) << endl; 
		};
		cout << "Sammelruf\tMSN = " << oSD.sGetSammelrufMSN() << endl;
		for (i=1; i <= 4; i++)
		{
			if (oSD.bGetSammelrufEintrag(i))
				cout << "\tPort " << i << endl;
		};
		cout << "Fernprog\tMSN = " << oSD.sGetFernprogMSN() << endl;
		cout << "Fernprog\tPW  = " << oSD.sGetFernprogPW() << endl;
		
		// loop over all MSNs found for ports
		list<string> oMSNList;
		list<string>::const_iterator oIter;
		for (i=1; i <= 4; i++)
		{
			if (oSD.sGetPortMSN(i)  != "") {
				oMSNList.push_back(oSD.sGetPortMSN(i));
			};
		};
		if (oSD.sGetSammelrufMSN() != "") {
			oMSNList.push_back(oSD.sGetSammelrufMSN());
		}
		if (oSD.sGetFernprogMSN() != "") {
			oMSNList.push_back(oSD.sGetFernprogMSN());
		}
		for(oIter = oMSNList.begin(); oIter != oMSNList.end(); ++oIter)
		{
			if (oSD.bGetRufumleitungCFUActive(*oIter))
				cout << (*oIter) << " CFU-> " << oSD.sGetRufumleitungCFU(*oIter) << endl;
			if (oSD.bGetRufumleitungCFNRActive(*oIter))
				cout << (*oIter) << " CFNR-> " << oSD.sGetRufumleitungCFNR(*oIter) << endl;
			if (oSD.bGetRufumleitungCFBActive(*oIter))
				cout << (*oIter) << " CFB-> " << oSD.sGetRufumleitungCFB(*oIter) << endl;
			if (oSD.bGetRufumleitungBK2Active(*oIter))
				cout << (*oIter) << " BK2-> " << oSD.sGetRufumleitungBK2(*oIter) << endl;
			cout << (*oIter) << " unterdrueckt = " << oSD.bGetCallerIDSuppression(*oIter) << endl;
		}

		oSD.vClose();
	}
	else
		cout << "SpeedDragon nicht sprechbar" << endl;
	
	cout << endl;

	return 0;
}

