//
// sd_redirect.cpp
//
// (c) Jan Willamowius, 1998
//
// free for private use - commercial use or commercial distribution
// requires permission from the author
//

#include <iostream>
#include <string.h>
#include "sd.hpp"


int main(int argc, char** argv)
{
	if ((argc < 3) || (argc > 4))
	{
		cout << "Usage: sd_redirect <on|off> <source MSN> [dest. MSN]" << endl;
		exit(1);
	};

#ifdef linux
	// i made a link to the serial device my SpeedDragon is connected to
	ocSpeedDragon oSD("/dev/speeddragon");
#endif
#ifdef _MSC_VER
#define strcasecmp	stricmp
	ocSpeedDragon oSD("/dev/speeddragon", 115200);
#endif
//	oSD.vSetDebug(true);

	oSD.vOpen();
	if (oSD.bIsOpen())
	{
		string sOnOff(argv[1]);
		string sSource(argv[2]);
		if ((strcasecmp(sOnOff.c_str(), "off") == 0) &&
		    (oSD.bGetRufumleitungBK2Active(sSource)))
		{
			oSD.vRufumleitungBK2Off(sSource);
			cout << "SD: Call redirection for " << sSource << " cleared" << endl;
		}
		else if ((strcasecmp(sOnOff.c_str(), "on") == 0) &&
		         (!oSD.bGetRufumleitungBK2Active(sSource)))
		{
			string sDestination(argv[3]);
			oSD.vSetRufumleitungBK2(sSource, sDestination);
			oSD.vRufumleitungBK2On(sSource);
			cout << "SD: Call redirection for " << sSource << " to " << sDestination << endl;
		}
		else {
			cout << "Usage: sd_redirect <on|off> <source MSN> [dest. MSN]" << endl;
			exit(1);
		};
		oSD.vClose();
	}
	else
		cout << "SpeedDragon not ready" << endl;
	
	cout << endl;

	return 0;
}

