//
// sd_suppress.cpp
//
// (c) Jan Willamowius, 1998
//
// free for private use - commercial use or commercial distribution
// requires permission from the author
//

#include <iostream>
#include <string.h>
#include "sd.hpp"

const char USAGE[] = "Usage: sd_suppress <on|off> <MSN>";

int main(int argc, char** argv)
{
	if (argc != 3)
	{
		cout << USAGE << endl;
		exit(1);
	};

#ifdef linux
	// i made a link to the serial device my SpeedDragon is connected to
	ocSpeedDragon oSD("/dev/speeddragon");
#endif
#ifdef _MSC_VER
#define strcasecmp	stricmp
	ocSpeedDragon oSD("COM1", 115200);
#endif
//	oSD.vSetDebug(true);

	oSD.vOpen();
	if (oSD.bIsOpen())
	{
		string sOnOff(argv[1]);
		string sMSN(argv[2]);
		if (strcasecmp(sOnOff.c_str(), "off") == 0)
		{
			oSD.vSetCallerIDSuppression(sMSN, false);
			cout << "SD: CallerID suppression for " << sMSN << " OFF" << endl;
		}
		else if (strcasecmp(sOnOff.c_str(), "on") == 0)
		{
			oSD.vSetCallerIDSuppression(sMSN, true);
			cout << "SD: CallerID suppression for " << sMSN << " ON" << endl;
		}
		else {
			cout << USAGE << endl;
			exit(1);
		};
		oSD.vClose();
	}
	else
		cout << "SpeedDragon not ready" << endl;
	
	cout << endl;

	return 0;
}

