//
// sd_test.cpp
//
// (c) Jan Willamowius, 1998
//
// free for private use - commercial use or commercial distribution
// requires permission from the author
//

#include <iostream>
#include "sd.hpp"


int main(void)
{
#ifdef linux
	// i made a link to the serial device my SpeedDragon is connected to
	ocSpeedDragon oSD("/dev/speeddragon");
#endif
#ifdef _MSC_VER
	ocSpeedDragon oSD("COM1", 115200);
#endif
	int i;

	oSD.vSetDebug(true);
	oSD.vOpen();
	if (oSD.bIsOpen())
	{
		cout << "SpeedDragon ready..." << endl;
		cout << "Firmware Revision " << oSD.sGetFirmwareRevision() << endl;
//oSD.vSetPortMSN(4,"20981888");
//oSD.vSetGebuehrenfaktorPBX(12, 0);
//oSD.vSetBusyTone(2, SoftBusy);
//oSD.vClose();
//exit(1);
//		oSD.vClearCallList();
//		oSD.vSetLanguage(Deutsch);
//		oSD.vChangeBpsPermanently(115200);

		cout << "Sprache : " << oSD.xGetLanguage() << endl;
		cout << "Location : " << oSD.sGetLocation() << endl;
		cout << "ISDN-Netzkennung : " << oSD.xGetISDNNet() << endl;
		for (i=1; i <= 4; i++)
		{
			cout << "Port " << i << "\tMSN = " << oSD.sGetPortMSN(i) << endl;
			cout << "\t" << "PseudoDialtone = " << oSD.bGetPseudoDialtone(i) << endl;
			cout << "\t" << "Anklopfen = " << oSD.bGetAnklopfen(i) << endl;
		};
		for (i=0; i <= 6; i++)
		{
			cout << "DisplayPart " << i << " = " << oSD.bGetDisplayPart(tDisplayPart(i)) << endl; 
		};
		cout << "Sammelruf\tMSN = " << oSD.sGetSammelrufMSN() << endl;
		for (i=1; i <= 4; i++)
		{
			cout << "\tPort " << i << " = " << oSD.bGetSammelrufEintrag(i) << endl;
		};
		cout << "Fernprog\tMSN = " << oSD.sGetFernprogMSN() << endl;
		
		// better: loop over all MSNs found for ports
		// for now: just use my MSNs
		cout << "20981888 CFU-> " << oSD.bGetRufumleitungCFUActive("20981888") << " " << oSD.sGetRufumleitungCFU("20981888") << endl;
		cout << "20981844 CFU-> " << oSD.bGetRufumleitungCFUActive("20981844") << " " << oSD.sGetRufumleitungCFU("20981844") << endl;
		cout << "20981788 CFU-> " << oSD.bGetRufumleitungCFUActive("20981788") << " " << oSD.sGetRufumleitungCFU("20981788") << endl;
		cout << "20981888 BK2-> " << oSD.bGetRufumleitungBK2Active("20981888") << " " << oSD.sGetRufumleitungBK2("20981888") << endl;
		cout << "20981844 BK2-> " << oSD.bGetRufumleitungBK2Active("20981844") << " " << oSD.sGetRufumleitungBK2("20981844") << endl;
		cout << "20981788 BK2-> " << oSD.bGetRufumleitungBK2Active("20981788") << " " << oSD.sGetRufumleitungBK2("20981788") << endl;

		cout << "20981888 unterdrueckt = " << oSD.bGetCallerIDSuppression("20981888") << endl;
		cout << "20981844 unterdrueckt = " << oSD.bGetCallerIDSuppression("20981844") << endl;
		cout << "20981788 unterdrueckt = " << oSD.bGetCallerIDSuppression("20981788") << endl;
		

//		cout << endl << "Dialing..." << endl;
//		oSD.vDial(1, "123");
//		tDialResult xResult = Waiting;
//		while (xResult == Waiting )
//		{
//			xResult = oSD.xWaitForDialResult(1);
//			switch(xResult)
//			{
//				case NoResult:
//					cout << "NoResult" << endl;
//					break;
//				case Waiting:
//					cout << "Waiting" << endl;
//					break;
//				case Done:
//					cout << "Done" << endl;
//					break;
//				case Timeout:
//					cout << "Timeout" << endl;
//					break;
//				case PortBusy:
//					cout << "PortBusy" << endl;
//					break;
//				default:
//					cout << "No Result at all" << endl;
//					break;
//			};
//		};

		oSD.vClose();
	}
	else
		cout << "SpeedDragon nicht sprechbar" << endl;
	
	cout << endl;

	return 0;
}

