//
// sd.c
//
// (c) Jan Willamowius, 1998
//
// free for private use - commercial use or commercial distribution
// requires permission from the author
//

#include "sd.h"
#include "sd.hpp"

static ocSpeedDragon * poSD = NULL;

extern "C" {

void sd_vInit(const char * sDevice, int iBps)
{
	poSD = new ocSpeedDragon(sDevice, iBps);
};

void sd_vCleanup()
{
	if (poSD)
	{
		delete poSD;
		poSD = NULL;
	};
};

void sd_vOpen(void)
{
	poSD->vOpen();
};

void sd_vClose(void)
{
	poSD->vClose();
};

int sd_bIsOpen(void)
{
	return poSD->bIsOpen();
};

void sd_vSetDebug(int bOn)
{
	poSD->vSetDebug(bOn);
};

void sd_sGetFirmwareRevision(char * psBuf, int iBufSize)
{
	strncpy(psBuf, poSD->sGetFirmwareRevision().c_str(), iBufSize);
};

void sd_vClearCallList(void)
{
	poSD->vClearCallList();
};

void sd_vSetAmtsBerechtigungPort(tPort xNo, int xAmt)
{
	poSD->vSetAmtsBerechtigungPort(xNo, tAmtsBerechtigung(xAmt));
};

int sd_xGetAmtsBerechtigungPort(tPort xNo)
{
	return poSD->xGetAmtsBerechtigungPort(xNo);
};

void sd_vSetAmtsBerechtigungPBX(int xAmt)
{
	poSD->vSetAmtsBerechtigungPBX(tAmtsBerechtigung(xAmt));
};

int sd_xGetAmtsBerechtigungPBX(void)
{
	return poSD->xGetAmtsBerechtigungPBX();
};

void sd_vSetGebuehrenfaktorPort(tPort xNo, int iFaktor)
{
	poSD->vSetGebuehrenfaktorPort( xNo, iFaktor);
};

int sd_iGetGebuehrenfaktorPort(tPort xNo)
{
	return poSD->iGetGebuehrenfaktorPort(xNo);
};

void sd_vSetGebuehrenfaktorPBX(int iFaktor)
{
	poSD->vSetGebuehrenfaktorPBX(iFaktor);
};

int sd_iGetGebuehrenfaktorPBX(void)
{
	return poSD->iGetGebuehrenfaktorPBX();
};

int sd_iGetSummenzaehlerPort(tPort xNo)
{
	return poSD->iGetSummenzaehlerPort(xNo);
};

int sd_iGetSummenzaehlerPBX(void)
{
	return poSD->iGetSummenzaehlerPBX();
};

void sd_vClearSummenzaehlerPort(tPort xNo)
{
	poSD->vClearSummenzaehlerPort(xNo);
};

void sd_vClearSummenzaehlerPBX(void)
{
	poSD->vClearSummenzaehlerPBX();
};

void sd_vRufumleitungCFUOn(const char * sMSN)
{
	poSD->vRufumleitungCFUOn(sMSN);
};

void sd_vRufumleitungCFUOff(const char * sMSN)
{
	poSD->vRufumleitungCFUOff(sMSN);
};

int sd_bGetRufumleitungCFUActive(const char * sMSN)
{
	return poSD->bGetRufumleitungCFUActive(sMSN);
};

void sd_vSetRufumleitungCFU(const char * sMSN, const char * sNumber)
{
	poSD->vSetRufumleitungCFU(sMSN, sNumber);
};

void sd_sGetRufumleitungCFU(const char * sMSN, char * psBuf, int iBufSize)
{
	strncpy(psBuf, poSD->sGetRufumleitungCFU(sMSN).c_str(), iBufSize);
};

void sd_vRufumleitungBK2On(const char * sMSN)
{
	poSD->vRufumleitungBK2On(sMSN);
};

void sd_vRufumleitungBK2Off(const char * sMSN)
{
	poSD->vRufumleitungBK2Off(sMSN);
};

int sd_bGetRufumleitungBK2Active(const char * sMSN)
{
	return poSD->bGetRufumleitungBK2Active(sMSN);
};

void sd_vSetRufumleitungBK2(const char * sMSN, const char * sNumber)
{
	poSD->vSetRufumleitungBK2(sMSN, sNumber);
};

void sd_sGetRufumleitungBK2(const char * sMSN, char * psBuf, int iBufSize)
{
	strncpy(psBuf, poSD->sGetRufumleitungBK2(sMSN).c_str(), iBufSize);
};

void sd_vAllRufumleitungenOff(void)
{
	poSD->vAllRufumleitungenOff();
};

void sd_vSetCallerIDSupression(const char * sMSN, int xOn)
{
	poSD->vSetCallerIDSupression(sMSN, xOn);
};

int sd_bGetCallerIDSupression(const char * sMSN)
{
	return poSD->bGetCallerIDSupression(sMSN);
};

void sd_vSetSammelrufEintrag(tPort xNo, int bEintrag)
{
	poSD->vSetSammelrufEintrag(xNo, bEintrag);
};

int sd_bGetSammelrufEintrag(tPort xNo)
{
	return poSD->bGetSammelrufEintrag(xNo);
};

void sd_vSetPseudoDialtone(tPort xNo, int bOn)
{
	poSD->vSetPseudoDialtone(xNo, bOn);
};

int sd_bGetPseudoDialtone(tPort xNo)
{
	return poSD->bGetPseudoDialtone(xNo);
};

void sd_vSetAnklopfen(tPort xNo, int bOn)
{
	poSD->vSetAnklopfen(xNo, bOn);
};

int sd_bGetAnklopfen(tPort xNo)
{
	return poSD->bGetAnklopfen(xNo);
};

void sd_vSetDisplayPart(int xPart, int bOn)
{
	poSD->vSetDisplayPart(tDisplayPart(xPart), bOn);
};

int sd_bGetDisplayPart(int xPart)
{
	return poSD->bGetDisplayPart(tDisplayPart(xPart));
};

void sd_vSetLanguage(int xLanguage)
{
	poSD->vSetLanguage(tLanguage(xLanguage));
};

int sd_xGetLanguage(void)
{
	return poSD->xGetLanguage();
};

void sd_vSetISDNNet(int xISDN)
{
	poSD->vSetISDNNet(tISDNNet(xISDN));
};

int sd_xGetISDNNet(void)
{
	return poSD->xGetISDNNet();
};

void sd_vClearPortMSN(tPort xNo)
{
	poSD->vClearPortMSN(xNo);
};

void sd_vClearSammelrufMSN(void)
{
	poSD->vClearSammelrufMSN();
};

void sd_vClearFernprogMSN(void)
{
	poSD->vClearFernprogMSN();
};

void sd_vSetPortMSN(tPort xNo, const char * sMSN)
{
	poSD->vSetPortMSN(xNo, sMSN);
};

void sd_sGetPortMSN(tPort xNo, char * psBuf, int iBufSize)
{
	strncpy(psBuf, poSD->sGetPortMSN(xNo).c_str(), iBufSize);
};

void sd_vSetSammelrufMSN(const char * sMSN)
{
	poSD->vSetSammelrufMSN(sMSN);
};

void sd_sGetSammelrufMSN(char * psBuf, int iBufSize)
{
	strncpy(psBuf, poSD->sGetSammelrufMSN().c_str(), iBufSize);
};

void sd_vSetFernprogMSN(const char * sMSN)
{
	poSD->vSetFernprogMSN(sMSN);
};

void sd_sGetFernprogMSN(char * psBuf, int iBufSize)
{
	strncpy(psBuf, poSD->sGetFernprogMSN().c_str(), iBufSize);
};

// ohne fuehrende Nullen !!!
void sd_vSetLocation(const char * sCountry, const char * sArea)
{
	poSD->vSetLocation(sCountry, sArea);
};

void sd_sGetLocation(char * psBuf, int iBufSize)
{
	strncpy(psBuf, poSD->sGetLocation().c_str(), iBufSize);
};

void sd_vDial(tPort xNo, const char * sNumber)
{
	poSD->vDial(xNo, sNumber);
};

int sd_xWaitForDialResult(tPort xNo)
{
	return poSD->xWaitForDialResult(xNo);
};

}

