#ifndef DIVERSIONDLG_H
#define DIVERSIONDLG_H

#include <stdio.h>
#include <qdialog.h>
#include <qapplication.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qlistview.h>
#include <qbuttongroup.h>
#include <qradiobutton.h>
#include <qcheckbox.h>
#include <qpushbutton.h>
#include <qcombobox.h>

#define MAX_ID 12

enum divPort { Port1, Port2, Port3, PC, Collective };
enum divStatus { divOff, divBK2, divCFU, divCFNR, divCFB, divCFNRCFB };

class divDlg : public QDialog {
	Q_OBJECT

public:
	divDlg(QWidget *parent=0, const char *name=0);

	void addMSN(const char *MSN, divPort port, divStatus status=divOff, 
		const char* divID="-");
	void removeAllMSNs(void);
	const char* getSelectedMSN(void);
	divStatus getSelectedType(void);
	const char* getSelectedID(int position=0);
	
signals:
	void activate(void);
	void deactivate(void);
	void deactivateAll(void);
	
private:
	QListView *divlist;
	QPushButton *b_act, *b_deact, *b_all, *b_CFOK;
	QCheckBox *cb_BK2, *cb_CFU, *cb_CFB, *cb_CFNR;
	QLineEdit *le_IDBK2, *le_IDCFU, *le_IDCFNR, *le_IDCFB;
	
private slots:
	void MSNSelected(QListViewItem *item);
	void activationDialog(void);
	void CFClicked(void);
};

#endif
