#ifndef NETDLG_H
#define NETDLG_H

#include <qdialog.h>
#include <qcombobox.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qlabel.h>
#include "sd.hpp"

struct netDlgChanged {
	bool ISDNNet;
	bool MSNTrans;
	bool service;
};

class netDlg : public QDialog {
	Q_OBJECT

public:
	netDlg(QWidget *parent=0, const char *name=0);
	
	void setISDNNet(tISDNNet type);
	tISDNNet getISDNNet(void);
	bool isISDNNetChanged(void) { return(Changed.ISDNNet); }
	void setMSNTrans(tMSNTransmission type);
	tMSNTransmission getMSNTrans(void);
	bool isMSNTransChanged(void) { return(Changed.MSNTrans); }
	void setService(tDienstkennung type);
	tDienstkennung getService(void);
	bool isServiceChanged(void) { return(Changed.service); }
	void resetStatusChanged(void);
	
private:
	netDlgChanged Changed;
	QComboBox *combo_net, *combo_trans, *combo_service;

private slots:	
	void ISDNNetChanged(void) { Changed.ISDNNet=TRUE; }
	void MSNTransChanged(void) { Changed.MSNTrans=TRUE; }
	void serviceChanged(void) { Changed.service=TRUE; }
};

#endif

