#include "remotedlg.h"

#ifdef ENGLISH
static const char *remoteCaption="Remote programming";
static const char *remoteLabelMSN="MSN:";
static const char *remoteLabelMSN="Password:";
static const char *remoteOkButton="Ok";
static const char *remoteCancelButton="Cancel";
#else
static const char *remoteCaption="Fernprogrammierung";
static const char *remoteLabelMSN="MSN:";
static const char *remoteLabelPass="Passwort:";
static const char *remoteOkButton="Ok";
static const char *remoteCancelButton="Abbruch";
#endif

remoteDlg::remoteDlg(QWidget *parent, const char *name) 
	: QDialog(parent, name, TRUE)
{
	
	QHBoxLayout base(this);
	
	setFixedSize(270,100);
	setCaption(remoteCaption);
	
	/*left margin */
	base.addSpacing(20);
	
	/* label */
	QBoxLayout *buttons=new QVBoxLayout();
	base.addLayout(buttons);
	buttons->addSpacing(20);
	QLabel *l_MSN=new QLabel(remoteLabelMSN, this);
	buttons->addWidget(l_MSN);
	buttons->addSpacing(10);
	QLabel *l_pass=new QLabel(remoteLabelPass, this);
	buttons->addWidget(l_pass);
	buttons->addSpacing(20);
	
	/* combo box*/
	buttons=new QVBoxLayout();
	base.addLayout(buttons);
	buttons->addSpacing(20);
	le_MSN=new QLineEdit(this);
	le_MSN->setMaxLength(MAX_MSN);
	connect(le_MSN, SIGNAL(textChanged(const char*)), SLOT(MSNChanged()));
	buttons->addWidget(le_MSN);
	buttons->addSpacing(10);
	le_pass=new QLineEdit(this);
	le_pass->setMaxLength(MAX_PASS);
	connect(le_pass, SIGNAL(textChanged(const char*)), SLOT(passwordChanged()));
	buttons->addWidget(le_pass);
	buttons->addSpacing(20);
	
	base.addSpacing(30);
	
	/* buttons */
	buttons=new QVBoxLayout();
	base.addLayout(buttons);
	buttons->addSpacing(20);
	QPushButton *b_ok=new QPushButton(remoteOkButton, this);
	b_ok->setDefault(TRUE);
	buttons->addWidget(b_ok);
	buttons->addSpacing(10);
	QPushButton *b_cancel=new QPushButton(remoteCancelButton, this);
	buttons->addWidget(b_cancel);
	buttons->addSpacing(20);
	
	/* right margin */
	base.addSpacing(20);
	
	base.activate();
	setFixedSize(size());
	
	resetStatusChanged();
	connect(b_ok, SIGNAL(clicked()), SLOT(accept()));
	connect(b_cancel, SIGNAL(clicked()), SLOT(reject()));
}

void remoteDlg::setMSN(const char *MSN) {
	le_MSN->setText(MSN);
}

const char* remoteDlg::getMSN(void) {
	return(le_MSN->text());
}

void remoteDlg::setPassword(const char *password) {
	le_pass->setText(password);
}

const char* remoteDlg::getPassword(void) {
	return(le_pass->text());
}

void remoteDlg::resetStatusChanged(void) {
	Changed.MSN=FALSE;
	Changed.password=FALSE;
}
