#ifndef TABADAPTER_H
#define TABADAPTER_H

#include <stdio.h>
#include <stdlib.h>
#include <qpushbutton.h>
#include <qlineedit.h>
#include <qcombobox.h>
#include <qgroupbox.h>
#include <qbuttongroup.h>
#include <qlabel.h>
#include <qradiobutton.h>
#include <string>
#include "sd.hpp"

struct adapterChanged {
	bool AreaCode;
	bool Authorization;
	bool Counter;
	bool Factor;
};

class tabAdapter : public QWidget {
	Q_OBJECT

public:
	tabAdapter(QWidget *parent=0, const char *name=0);
	
	void setAuthorization(tAmtsBerechtigung type);
	tAmtsBerechtigung getAuthorization(void);
	bool isAuthorizationChanged(void) { return(Changed.Authorization); } 
	void setCountry(int country_code);
	int getCountry(void);
	void setAreaCode(const char *area);
	const char* getAreaCode(void);
	bool isAreaCodeChanged(void) { return(Changed.AreaCode); } 
	void setCounter(int charge);
	int getCounter(void);
	bool isCounterChanged(void) { return(Changed.Counter); } 
	void setFactor(int factor, int nachkomma=0);
	int getFactor(void);
	int getNachkommaFactor(void);
	bool isFactorChanged(void) { return(Changed.Factor); } 
	void resetStatusChanged(void);
	bool isTabAdapterChanged(void);
	
public slots:
	void resetCounter(void);
	
private:
	adapterChanged Changed;
	QComboBox *combo_country;
	QRadioButton *rb_loc, *rb_nat, *rb_inat;
	QLineEdit *le_info, *le_factor, *le_area;

private slots:
	void areaCodeChanged(void) { Changed.AreaCode=TRUE; }
	void authorizationChanged(void) { Changed.Authorization=TRUE; }
	void counterChanged(void) { Changed.Counter=TRUE; }
	void factorChanged(void) { Changed.Factor=TRUE; }
};

#endif
