#include "tabcollective.h"
#include "lang.h"

tabCollective::tabCollective(QWidget *parent, const char *name): QWidget(parent,name)
{
	QGroupBox *g_ports;
	QLabel *l_MSN;
	
	int x_MSN=50, y_MSN=30;
	int x_ports=20 ,y_ports=90;
	int x_cb=15, y_cb=20;
	
	setFixedSize(500, 220);
	
	/*MSN*/
	le_MSN=new QLineEdit(this);
	le_MSN->setStyle(WindowsStyle);
	l_MSN=new QLabel(le_MSN, "MSN:", this);
	l_MSN->setGeometry(x_MSN, y_MSN, 30, 25);
	le_MSN->setGeometry(x_MSN+35, y_MSN, 100, 25);
	le_MSN->setMaxLength(MAX_MSN);
	connect(le_MSN, SIGNAL(textChanged(const char*)), SLOT(MSNChanged()));
	
	/* Suppression */
	cb_suppression=new QCheckBox("MSN Unterdrckung", this);
	cb_suppression->setGeometry(200, 30, 150,25);
	connect(cb_suppression, SIGNAL(clicked()), SLOT(MSNSuppressionChanged()));
	
	/* Ports */
	g_ports=new QGroupBox("eingetragene Ports", this);
	g_ports->setGeometry(x_ports, y_ports, 150, 110);
	cb_port1=new QCheckBox("Port 1",g_ports);
	cb_port1->setGeometry(x_cb, y_cb, 100, 25);
	connect(cb_port1, SIGNAL(clicked()), SLOT(port1Changed()));
	cb_port2=new QCheckBox("Port 2", g_ports);
	cb_port2->setGeometry(x_cb, y_cb+20, 100, 25);
	connect(cb_port2, SIGNAL(clicked()), SLOT(port2Changed()));
	cb_port3=new QCheckBox("Port 3", g_ports);
	cb_port3->setGeometry(x_cb, y_cb+40, 100, 25);
	connect(cb_port3, SIGNAL(clicked()), SLOT(port3Changed()));
	cb_pc=new QCheckBox("PC", g_ports);
	cb_pc->setGeometry(x_cb, y_cb+60, 100, 25);
	connect(cb_pc, SIGNAL(clicked()), SLOT(pcChanged()));
}

void tabCollective::setMSN(const char *MSN) {
	le_MSN->setText(MSN);
}

const char* tabCollective::getMSN(void) {
	return(le_MSN->text());
}

void tabCollective::setPort(int port, bool val) {
	switch(port) {
		case 1: cb_port1->setChecked(val);
			break;
		case 2: cb_port2->setChecked(val);
			break;
		case 3: cb_port3->setChecked(val);
			break;
		case 4: cb_pc->setChecked(val);
			break;
	}
}

bool tabCollective::getPort(int port) {
	switch(port) {
		case 1: return(cb_port1->isChecked());
			break;
		case 2: return(cb_port2->isChecked());
			break;
		case 3: return(cb_port3->isChecked());
			break;
		case 4: return(cb_pc->isChecked());
	}
	return(FALSE);
}

void tabCollective::setMSNSuppression(bool val) {
	cb_suppression->setChecked(val);
}

bool tabCollective::getMSNSuppression(void) {
	return(cb_suppression->isChecked());
}

void tabCollective::resetStatusChanged(void) {
	
	int i;

	for (i=1; i<=4; i++)
		Changed.port[i]=FALSE;
	Changed.MSN=FALSE;
	Changed.MSNSuppression=FALSE;
}

bool tabCollective::isTabCollectiveChanged(void) {
	if (Changed.port[1] || Changed.port[2] || Changed.port[3] ||
		Changed.port[4] || Changed.MSN || Changed.MSNSuppression)
		return(TRUE);
	else
		return(FALSE);
}

void tabCollective::MSNChanged(void) {
	Changed.MSN=TRUE;
	if(strlen(getMSN()) > 0) {
		cb_suppression->setEnabled(TRUE);
	}
	else {
		cb_suppression->setEnabled(FALSE);
		cb_suppression->setChecked(FALSE);
	}
}
