#ifndef TABCOLLECTIVE_H
#define TABCOLLECTIVE_H

#include <qgroupbox.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qcheckbox.h>

struct collectiveChanged {
	bool MSN;
	bool port[5];
	bool MSNSuppression;
};

class tabCollective : public QWidget {
	Q_OBJECT

public:
	tabCollective(QWidget *parent=0, const char *name=0);
	
	void setMSN(const char *MSN);
	const char* getMSN(void);
	bool isMSNChanged(void) { return(Changed.MSN); }
	void setPort(int port, bool checked);
	bool getPort(int port);
	bool isPortChanged(int port) { return(Changed.port[port]); }
	void setMSNSuppression(bool val);
	bool getMSNSuppression(void);
	bool isMSNSuppressionChanged(void) { return(Changed.MSNSuppression); }
	void resetStatusChanged(void);
	bool isTabCollectiveChanged(void);
		
private:
	collectiveChanged Changed;
	QCheckBox *cb_port1, *cb_port2, *cb_port3, *cb_pc, *cb_suppression;
	QLineEdit *le_MSN;

private slots:
	void port1Changed(void) { Changed.port[1]=TRUE; }
	void port2Changed(void) { Changed.port[2]=TRUE; }
	void port3Changed(void) { Changed.port[3]=TRUE; }
	void pcChanged(void) { Changed.port[4]=TRUE; }
	void MSNChanged(void);
	void MSNSuppressionChanged(void) { Changed.MSNSuppression=TRUE; }
};

#endif
