#ifndef TABDIALOG_H
#define TABDIALOG_H

#include <stdio.h>
#include <qapplication.h>
#include <qtabbar.h>
#include <qlayout.h>
#include <qwidgetstack.h>
#include <qobjectlist.h>

class tabDialog : public QWidget {
	Q_OBJECT

public:
	tabDialog(QWidget *parent=0, const char *name=0);
	int addTab(QWidget *child, const char* label);
	void showTab(int id);
	void showTab(QWidget *child);
	int currentTab(void);
	void setTabEnabled(int id, bool val);
	void setTabWidgetsEnabled(int id, bool val);

signals:
	void tabSelected(int id);
	
private:
	QBoxLayout *layout;
	QTabBar *tabbar;
	QWidgetStack *stack;
	
	void tabDialog::paintEvent( QPaintEvent * );
	void updateLayout(void);
};

#endif
