#ifndef TABDISPLAY_H
#define TABDISPLAY_H

#include <qcombobox.h>
#include <qgroupbox.h>
#include <qbuttongroup.h>
#include <qlabel.h>
#include <qradiobutton.h>
#include <qcheckbox.h>
#include "sd.hpp"

enum tMSN { MSN_Off, MSN_Diverted, MSN_All };
enum tbchannel { B_Off, B_Normal, B_Advanced };

struct displayChanged {
	bool Language;
	bool BChannel;
	bool MSN;
	bool Charge;
	bool Caller;
	bool List;
};


class tabDisplay : public QWidget {
	Q_OBJECT

public:
	tabDisplay(QWidget *parent=0, const char *name=0);
	
	void setLanguage(tLanguage type);
	tLanguage getLanguage(void);
	bool isLanguageChanged(void) { return(Changed.Language); }
	void setMSN(tMSN type);
	tMSN getMSN(void);
	bool isMSNChanged(void) { return(Changed.MSN); }
	void setBChannel(tbchannel type);
	tbchannel getBChannel(void);
	bool isBChannelChanged(void) { return(Changed.BChannel); }
	void setCharge(bool val);
	bool getCharge(void);
	bool isChargeChanged(void) { return(Changed.Charge); }
	void setCaller(bool val);
	bool getCaller(void);
	bool isCallerChanged(void) { return(Changed.Caller); }
	void setList(bool val);
	bool getList(void);
	bool isListChanged(void) { return(Changed.List); }
	void resetStatusChanged(void);
	bool isTabDisplayChanged(void);

private slots:
	void MSN_toggled(void);
	void BChannel_toggled(void);
	void languageChanged(void) { Changed.Language=TRUE; }
	void MSNChanged(void) { Changed.MSN=TRUE; }
	void bChannelChanged(void) { Changed.BChannel=TRUE; }
	void chargeChanged(void) { Changed.Charge=TRUE; }
	void listChanged(void) { Changed.List=TRUE; }
	void callerChanged(void) { Changed.Caller=TRUE; }
	
private:
	displayChanged Changed;
	QComboBox *combo_language;
	QCheckBox *cb_MSN, *cb_bchannel, *cb_charge, *cb_list, *cb_caller;
	QRadioButton *rb_diverted, *rb_all, *rb_normal, *rb_advanced;
};

#endif
