#ifndef TABPORT_H
#define TABPORT_H

#include <stdio.h>
#include <stdlib.h>
#include <qcombobox.h>
#include <qpushbutton.h>
#include <qlineedit.h>
#include <qgroupbox.h>
#include <qbuttongroup.h>
#include <qlabel.h>
#include <qradiobutton.h>
#include <qcheckbox.h>
#include "sd.hpp"

struct portChanged {
	bool MSN;
	bool Authorization;
	bool BusyTone;
	bool Counter;
	bool Factor;
	bool DialTone;
	bool CallWaiting;
	bool MSNSuppression;
};

class tabPort : public QWidget {
	Q_OBJECT

public:
	tabPort(QWidget *parent=0, const char *name=0);
	
	void setPort4(bool val);
	void setAuthorization(tAmtsBerechtigung type);
	tAmtsBerechtigung getAuthorization(void);
	bool isAuthorizationChanged(void) { return(Changed.Authorization); }
	void setBusyTone(tBusyTone type);
	tBusyTone getBusyTone(void);
	bool isBusyToneChanged(void) { return(Changed.BusyTone); } 
	void setMSN(const char* MSN);
	const char* getMSN(void);
	bool isMSNChanged(void) { return(Changed.MSN); }
	void setCallWaiting(bool val);
	bool getCallWaiting();
	bool isCallWaitingChanged(void) { return(Changed.CallWaiting); }
	void setDialTone(bool val);
	bool getDialTone(void);
	bool isDialToneChanged(void) { return(Changed.DialTone); }
	void setMSNSuppression(bool val);
	bool getMSNSuppression(void);
	bool isMSNSuppressionChanged(void) { return(Changed.MSNSuppression); }
	void setCounter(int charge);
	int getCounter(void);
	bool isCounterChanged(void) { return(Changed.Counter); }
	void setFactor(int factor, int nachkomma=0);
	int getFactor(void);
	int getNachkommaFactor(void);
	bool isFactorChanged(void) { return(Changed.Factor); }
	void resetStatusChanged(void);
	bool isTabPortChanged(void);
	
public slots:
	void resetCounter(void);
	
private:
	portChanged Changed;
	QRadioButton *rb_no, *rb_loc, *rb_nat, *rb_inat;
	QButtonGroup *g_busy;
	QRadioButton *rb_hard, *rb_soft, *rb_off;
	QCheckBox *cb_tone, *cb_waiting, *cb_suppression;
	QLineEdit *le_MSN, *le_info, *le_factor;
	QComboBox *combo_busy;

private slots:
	void MSNChanged(void);
	void authorizationChanged(void) { Changed.Authorization=TRUE; }
	void busyToneChanged(void) { Changed.BusyTone=TRUE; }
	void counterChanged(void) { Changed.Counter=TRUE; }
	void factorChanged(void) { Changed.Factor=TRUE; }
	void dialToneChanged(void) { Changed.DialTone=TRUE; }
	void callWaitingChanged(void) { Changed.CallWaiting=TRUE; }
	void MSNSuppressionChanged(void) { Changed.MSNSuppression=TRUE; }
};

#endif
